%global debug_package %{nil}

%if 0%{?fedora} >= 35
%bcond_without guile30
%else
%bcond_with guile30
%endif

# This is a temporary work-around until the fixes for
# https://github.com/rpm-software-management/rpm/issues/1765 land in
# Fedora.
%global __brp_strip /bin/true

%global srcname irregex

Name:           guile-%{srcname}
Version:        0.9.11
Release:        1%{?dist}
Summary:        Scheme regular expressions library

License:        BSD
URL:            https://synthcode.com/scheme/irregex
Source0:        https://synthcode.com/scheme/irregex/irregex-%{version}.tar.gz

%global _description %{expand:
A fully portable and efficient R[4567]RS implementation of regular
expressions, supporting both POSIX syntax with various (irregular)
PCRE extensions, as well as SCSH's SRE syntax, with various aliases
for commonly used patterns.}

%description %_description


%package -n guile22-%{srcname}
Summary:        Scheme regular expressions library
BuildRequires:  guile22-devel
Requires:       guile22
Provides:       guile-%{srcname} = %{version}-%{release}
Obsoletes:      guile-%{srcname} <= 0.9.10-1
Recommends:     guile-irregex-doc

%description -n guile22-%{srcname} %_description


%if %{with guile30}
%package -n guile30-%{srcname}
Summary:        Scheme regular expressions library
BuildRequires:  guile30-devel
Requires:       guile30
Recommends:     guile-irregex-doc

%description -n guile30-%{srcname} %_description
%endif


%package doc
Summary:        Documentation for guile-irregex

%description doc %_description


%prep
%setup -qc
mv %{srcname}-%{version} guile22

%if %{with guile30}
cp -a guile22 guile30
%endif


%build
pushd guile22
guild2.2 compile -o irregex-guile.go irregex-guile.scm
guild2.2 compile -o irregex.go irregex.scm
guild2.2 compile -o irregex-utils.go irregex-utils.scm
popd

%if %{with guile30}
pushd guile30
guild3.0 compile -o irregex-guile.go irregex-guile.scm
guild3.0 compile -o irregex.go irregex.scm
guild3.0 compile -o irregex-utils.go irregex-utils.scm
popd
%endif


%install
rm -rf $RPM_BUILD_ROOT

pushd guile22
mkdir -p $RPM_BUILD_ROOT%{_libdir}/guile/2.2/site-ccache/rx
install -p -m 644 irregex-guile.go $RPM_BUILD_ROOT%{_libdir}/guile/2.2/site-ccache/rx/irregex.go
install -p -m 644 irregex-utils.go $RPM_BUILD_ROOT%{_libdir}/guile/2.2/site-ccache/rx
mkdir -p $RPM_BUILD_ROOT%{_libdir}/guile/2.2/site-ccache/rx/source
install -p -m 644 irregex.go $RPM_BUILD_ROOT%{_libdir}/guile/2.2/site-ccache/rx/source

mkdir -p $RPM_BUILD_ROOT%{_datadir}/guile/site/2.2/rx
install -p -m 644 irregex-guile.scm $RPM_BUILD_ROOT%{_datadir}/guile/site/2.2/rx/irregex.scm
install -p -m 644 irregex-utils.scm $RPM_BUILD_ROOT%{_datadir}/guile/site/2.2/rx
mkdir -p $RPM_BUILD_ROOT%{_datadir}/guile/site/2.2/rx/source
install -p -m 644 irregex.scm $RPM_BUILD_ROOT%{_datadir}/guile/site/2.2/rx/source
popd

%if %{with guile30}
pushd guile30
mkdir -p $RPM_BUILD_ROOT%{_libdir}/guile/3.0/site-ccache/rx
install -p -m 644 irregex-guile.go $RPM_BUILD_ROOT%{_libdir}/guile/3.0/site-ccache/rx/irregex.go
install -p -m 644 irregex-utils.go $RPM_BUILD_ROOT%{_libdir}/guile/3.0/site-ccache/rx
mkdir -p $RPM_BUILD_ROOT%{_libdir}/guile/3.0/site-ccache/rx/source
install -p -m 644 irregex.go $RPM_BUILD_ROOT%{_libdir}/guile/3.0/site-ccache/rx/source

mkdir -p $RPM_BUILD_ROOT%{_datadir}/guile/site/3.0/rx
install -p -m 644 irregex-guile.scm $RPM_BUILD_ROOT%{_datadir}/guile/site/3.0/rx/irregex.scm
install -p -m 644 irregex-utils.scm $RPM_BUILD_ROOT%{_datadir}/guile/site/3.0/rx
mkdir -p $RPM_BUILD_ROOT%{_datadir}/guile/site/3.0/rx/source
install -p -m 644 irregex.scm $RPM_BUILD_ROOT%{_datadir}/guile/site/3.0/rx/source
popd
%endif


%files -n guile22-%{srcname}
%{_libdir}/guile/2.2/site-ccache/rx
%{_datadir}/guile/site/2.2/rx

%if %{with guile30}
%files -n guile30-%{srcname}
%{_libdir}/guile/3.0/site-ccache/rx
%{_datadir}/guile/site/3.0/rx
%endif

%files doc
%doc guile22/README guile22/irregex.html
